No puede seleccionar más de 25 temas Los temas deben comenzar con una letra o número, pueden incluir guiones ('-') y pueden tener hasta 35 caracteres de largo.
 
 
 
 

376 líneas
17 KiB

  1. #!/bin/sh
  2. command -V gpg >/dev/null 2>&1 && GPG="gpg" || GPG="gpg2"
  3. [ -z ${PASSWORD_STORE_DIR+x} ] && PASSWORD_STORE_DIR="$HOME/.password-store"
  4. [ -r "$PASSWORD_STORE_DIR/.gpg-id" ] &&
  5. "$GPG" --list-secret-keys "$(cat "$PASSWORD_STORE_DIR/.gpg-id")" >/dev/null 2>&1 || {
  6. printf "\`pass\` must be installed and initialized to encrypt passwords.\\nBe sure it is installed and run \`pass init <yourgpgemail>\`.\\nIf you don't have a GPG public private key pair, run \`%s --full-gen-key\` first.\\n" "$GPG"
  7. exit
  8. }
  9. ! command -v mbsync >/dev/null && printf "\`mbsync (isync package)\` must be installed to run mutt-wizard.\\n" && exit
  10. prefix="/usr/local"
  11. muttdir="$HOME/.config/mutt" # Main mutt config location
  12. accdir="$muttdir/accounts" # Directory for account settings
  13. maildir="$HOME/.local/share/mail" # Location of mail storage
  14. namere="^[a-z_][a-z0-9_-]*$" # Regex to ensure viable username
  15. emailre=".\+@.\+\\..\+" # Regex to confirm valid email address
  16. muttshare="$prefix/share/mutt-wizard"
  17. mbsyncrc="$HOME/.mbsyncrc"
  18. mwconfig="$muttshare/mutt-wizard.muttrc"
  19. cachedir="$HOME/.cache/mutt-wizard"
  20. muttrc="$muttdir/muttrc"
  21. msmtprc="$HOME/.config/msmtp/config"
  22. ssltype="IMAPS" # This is later changed to `None` later in the script if using Protonmail
  23. for x in "/etc/ssl/certs/ca-certificates.crt" "/etc/pki/tls/certs/ca-bundle.crt" "/etc/ssl/ca-bundle.pem" "/etc/pki/tls/cacert.pem" "/etc/pki/ca-trust/extracted/pem/tls-ca-bundle.pem" "/etc/ssl/cert.pem" "/usr/local/share/ca-certificates/"
  24. do
  25. [ -f "$x" ] && sslcert="$x" && break
  26. done || { echo "CA Certificate not found. Please install one or link it to /etc/ssl/certs/ca-certificates.crt" && exit 1 ;}
  27. getaccounts() { accounts="$(find "$accdir" -type f | grep -o "[0-9]-.*.muttrc" | sed "s/-/: /;s/\..*//" | sort -n)" ;}
  28. list() { getaccounts && [ -n "$accounts" ] && echo "$accounts" ;}
  29. getprofiles() { \
  30. unset msmtp_header msmtp_profile mutt_profile mbsync_profile
  31. printf "Creating profiles for \`%s\`..." "$title"
  32. msmtp_header="defaults
  33. auth on
  34. tls on
  35. tls_trust_file $sslcert
  36. logfile ~/.config/msmtp/msmtp.log
  37. "
  38. msmtp_profile="account $title
  39. host $smtp
  40. port $sport
  41. from $fulladdr
  42. user $login
  43. passwordeval \"pass $accpass\"
  44. $starttlsoff
  45. "
  46. mbsync_profile="IMAPStore $title-remote
  47. Host $imap
  48. Port $iport
  49. User $login
  50. PassCmd \"pass $accpass\"
  51. AuthMechs LOGIN
  52. SSLType $ssltype
  53. CertificateFile $sslcert
  54. MaildirStore $title-local
  55. Subfolders Verbatim
  56. Path ~/.local/share/mail/$title/
  57. Inbox ~/.local/share/mail/$title/INBOX
  58. Flatten .
  59. Channel $title
  60. Expunge Both
  61. Master :$title-remote:
  62. Slave :$title-local:
  63. Patterns * !\"[Gmail]/All Mail\"
  64. Create Both
  65. SyncState *
  66. MaxMessages $maxmes
  67. ExpireUnread no
  68. # End profile
  69. "
  70. if [ "$accounttype" = "offline" ]; then
  71. mutt_profile="# vim: filetype=neomuttrc
  72. # muttrc file for account $title
  73. set realname = \"$realname\"
  74. set from = \"$fulladdr\"
  75. set sendmail = \"msmtp -a $title\"
  76. alias me $realname <$fulladdr>
  77. set folder = \"$maildir/$title\"
  78. set header_cache = $cachedir/$title/headers
  79. set message_cachedir = $cachedir/$title/bodies
  80. set mbox_type = Maildir
  81. set crypt_autosign = yes
  82. set crypt_opportunistic_encrypt = yes
  83. set pgp_self_encrypt = yes
  84. set pgp_default_key = $keyid
  85. bind index,pager gg noop
  86. bind index,pager g noop
  87. bind index,pager M noop
  88. bind index,pager C noop
  89. bind index gg first-entry
  90. macro index o \"<shell-escape>mailsync -V $title<enter>\" \"run mbsync to sync $title\"
  91. unmailboxes *
  92. "
  93. else
  94. mutt_profile="# vim: filetype=neomuttrc
  95. # muttrc file for account $title
  96. set realname = \"$realname\"
  97. set from = \"$fulladdr\"
  98. set sendmail = \"msmtp -a $title\"
  99. alias me $realname <$fulladdr>
  100. set folder = \"imaps://$login@$imap:$iport\"
  101. set imap_user = \"$login\"
  102. set header_cache = $cachedir/$title/headers
  103. set message_cachedir = $cachedir/$title/bodies
  104. set imap_pass = \"\`pass $accpass\`\"
  105. set crypt_autosign = yes
  106. set crypt_opportunistic_encrypt = yes
  107. set pgp_self_encrypt = yes
  108. set pgp_default_key = $keyid
  109. set mbox_type = Maildir
  110. set ssl_starttls = yes
  111. set ssl_force_tls = yes
  112. bind index,pager gg noop
  113. bind index,pager g noop
  114. bind index,pager M noop
  115. bind index,pager C noop
  116. bind index gg first-entry
  117. unmailboxes *
  118. "
  119. fi
  120. printf "DONE.\\n"
  121. }
  122. askinfo() { \
  123. printf "Insert the \033[31memail address\033[0m that you want to autoconfigure for mutt/mbsync\\n\tEmail: \033[36m"
  124. read -r fulladdr
  125. keyid=$("$GPG" --list-keys --with-colons "$fulladdr" | awk -F: '/^pub:/ { print $5 }')
  126. printf "\033[0m"
  127. while ! echo "$fulladdr" | grep "$emailre" >/dev/null; do
  128. printf "That is not a valid \033[31memail address\033[0m, please retype the desired email.\\n\\nEmail: \033[36m\t"
  129. read -r fulladdr
  130. printf "\033[0m"
  131. done
  132. domain="$(echo "$fulladdr" | sed "s/.*@//")"
  133. search_query=$domain
  134. case "$domain" in
  135. protonmail.com|protonmail.ch|pm.me)
  136. search_query='protonmail.com' ;;
  137. *)
  138. while : ; do
  139. printf "\nIs your email hosted with Protonmail? [yes/no] "
  140. read -r is_protonmail
  141. case $is_protonmail in
  142. [Yy][Ee][Ss]) search_query='protonmail.com' && break;;
  143. [Nn][Oo]) break;;
  144. *) printf 'Please answer Yes or No'
  145. esac; done;
  146. esac
  147. printf "\\nSearching for \033[32m%s\033[0m in \033[34m\`domains.csv\`\033[0m..." "$domain"
  148. serverinfo="$(grep "^$search_query" "$muttshare/domains.csv" 2>/dev/null)"
  149. if [ -z "$serverinfo" ]; then
  150. printf "Your email domain is not in mutt-wizard's database yet.\\nmutt-wizard will still autoconfigure everything, but you will have to manually type in your service's IMAP and SMTP server information.\\nYou can usually quickly find this by internet searching for it.\\n"
  151. printf "Insert the IMAP server for your email provider (excluding the port number)\\n\033[36m\t"
  152. read -r imap
  153. printf "\033[0mWhat is your server's IMAP port number? (Usually something like 993)\\n\033[36m\t"
  154. read -r iport
  155. printf "\033[0mInsert the SMTP server for your email provider (excluding the port number)\\n\033[36m\t"
  156. read -r smtp
  157. printf "\033[0mWhat is your server's SMTP port number? (Usually 587 or 465)\\n\033[36m\t"
  158. read -r sport
  159. printf "\033[0m\\nGreat! If you want to be helpful, copy the line below and you can add it to the \`domains.csv\` file on Github.\\nThis will make things easier for others who use your email provider.\\n\\n%s,%s,%s,%s,%s\\n\\nAlthough be sure to test to see if these settings work first! ;-)\\n" "$domain" "$imap" "$iport" "$smtp" "$sport"
  160. else
  161. IFS=, read -r service imap iport smtp sport <<EOF
  162. $serverinfo
  163. EOF
  164. printf "\\n\033[3;33mCongrats!\033[0m Server info has automatically been found, so you won't have to look anything up!\\n\t\033[1mIMAP server\033[0m: %s\\n\t\033[1mIMAP port\033[0m: %s\\n\t\033[1mSMTP server\033[0m: %s\\n\t\033[1mSMTP port\033[0m: %s\\nThis data will be used by the wizard.\\n" "$imap" "$iport" "$smtp" "$sport"
  165. case "$service" in
  166. gmail.com) printf "\033[31mREMEMBER: Gmail users must enable \"less secure\" (third-party) applications first for the sync to work:\\nhttps://support.google.com/accounts/answer/6010255\\n\033[0m" ;;
  167. protonmail.ch|protonmail.com|pm.me) printf "\033[31mREMEMBER: Protonmail users must install and configure Protonmail Bridge first for the sync to work:\\nhttps://protonmail.com/bridge/\\n\033[0m" && ssltype="None" ;;
  168. esac
  169. [ "$sport" = 465 ] && starttlsoff="tls_starttls off"
  170. fi
  171. printf "Enter the \033[35mfull name\033[0m you want to be identified by on this account.\\n\tReal name: "
  172. read -r realname
  173. printf "Enter a short, \033[36mone-word identifier\033[0m for this email account that will distinguish them from any other accounts you add.\\n\tAccount name: "
  174. read -r title
  175. while ! echo "$title" | grep "$namere" >/dev/null || ls "$accdir"/[0-9]"-$title.muttrc" >/dev/null 2>&1; do
  176. printf "\033[31mTry again\033[0m. Pick a nickname that is one word only including lowercase letters and _ or - and that you have \033[1mnot\033[0m used before.\\n\tAccount name: \033[36m\t"
  177. read -r title
  178. printf "\033[0m"
  179. done
  180. printf "If you already have a password stored for the account, insert the name now. Otherwise leave this prompt totally blank, and later you will be asked to set up a password.\033[0m\\n\tPassword name in pass(?): \033[36m"
  181. read -r accpass
  182. printf "\033[0m"
  183. [ -z "$accpass" ] && accpass=mutt-wizard-$title
  184. printf "If your account has a special username different from your address, insert it now. Otherwise leave this prompt totally blank.\\n\033[34mMost accounts will not have a separate login, so you should probably leave this blank.\033[0m\\n\tLogin(?): \033[36m"
  185. read -r login
  186. printf "\033[0m"
  187. [ -z "$login" ] && login="$fulladdr"
  188. [ "$accounttype" = "offline" ] && printf "If you want to limit the number of messages kept offline to a number, enter that number below. If you do not want to limit your mail and would like \`mbsync\` to sync all mail, press enter without typing a number.\\n\t" && read -r maxmes
  189. echo "$maxmes" | grep "[1-9]" >/dev/null || maxmes="0"
  190. getpass
  191. getprofiles
  192. mkdir -p "$muttdir" "$accdir" "$cachedir/$title/bodies" "$HOME/.config/msmtp"
  193. getaccounts
  194. for x in $(seq 1 9); do echo "$accounts" | grep "$x" >/dev/null 2>&1 || { export idnum="$x"; break ;}; done
  195. [ ! -f "$msmtprc" ] && echo "$msmtp_header" > "$msmtprc"
  196. echo "$msmtp_profile" >> "$msmtprc"
  197. command -V apt-get >/dev/null 2>&1 && ln -s "$msmtprc" "$HOME/.msmtprc" 2>/dev/null
  198. case "$service" in
  199. protonmail.ch|protonmail.com|pm.me) protonfinger || return 1 ;;
  200. esac
  201. echo "$mutt_profile" > "$accdir/$idnum-$title.muttrc"
  202. echo "$mbsync_profile" >> "$mbsyncrc"
  203. notmuchauto
  204. [ ! -f "$muttrc" ] && echo "# vim: filetype=neomuttrc" > "$muttrc" && echo "muttrc created."
  205. ! grep "^source.*mutt-wizard.muttrc" "$muttrc" >/dev/null && echo "source $mwconfig # mw-autogenerated" >> "$muttrc"
  206. ! grep "^source.*.muttrc" "$muttrc" | grep -v "$mwconfig" >/dev/null && echo "source $accdir/$idnum-$title.muttrc # mw-autogenerated" >> "$muttrc"
  207. echo "macro index,pager i$idnum '<sync-mailbox><enter-command>source $accdir/$idnum-$title.muttrc<enter><change-folder>!<enter>;<check-stats>' \"switch to $fulladdr\" # mw-autogenerated" >> "$muttrc"
  208. }
  209. protonfinger() { printf "Getting Protonmail bridge fingerprint...\\n"
  210. fingerprint="$(msmtp --serverinfo --host=127.0.0.1 --port=1025 --tls --tls-certcheck=off | grep SHA256: | sed 's/^.*: //')"
  211. sed -ibu "s/account $title/&\ntls_trust_file\ntls_fingerprint $fingerprint/" "$msmtprc" ; rm -f "$msmtprc"bu
  212. }
  213. getpass() { \
  214. if [ "$accpass" = "mutt-wizard-$title" ]; then
  215. while : ; do pass rm -f "$accpass" >/dev/null 2>&1;
  216. pass insert "$accpass" && break; done ; fi ;}
  217. formatShortcut() { \
  218. while read -r data; do { echo "macro index,pager g$1 \"<change-folder>$data<enter>\" \"go to $2\" # mw-autogenerated"
  219. echo "macro index,pager M$1 \";<save-message>$data<enter>\" \"move mail to $2\" # mw-autogenerated"
  220. echo "macro index,pager C$1 \";<copy-message>$data<enter>\" \"copy mail to $2\" # mw-autogenerated"; } >> "$accdir/$idnum-$title.muttrc"
  221. done ;}
  222. tryconnect() { mkdir -p "$maildir/$title"
  223. if mailboxes="$(mbsync -l "$title" | sed 's/\//./')" >/dev/null 2>&1 && [ -n "$mailboxes" ]; then
  224. [ "$accounttype" = "online" ] && sed -ibu "/IMAPStore $title-remote$/,/# End profile/d" "$mbsyncrc" ; rm -f "$mbsyncrc"bu
  225. printf "\033[32mMailboxes detected.\033[0m\\n"
  226. echo "$mailboxes" | xargs -I {} mkdir -p "$maildir/$title/{}"
  227. return 0
  228. else
  229. printf "\033[31m\033[31mLog-on not successful.\033[0m\\nIt seems that either you inputted the wrong password or server settings, or there are other requirements for your account out of the control of mutt-wizard.\\n"
  230. return 1
  231. fi ;}
  232. finalize() { \
  233. boxes="$(find "$maildir/$title/" -mindepth 1 -type d | sed "s/\ /\\\ /g;s/^.*\//=/;/=\(cur\|new\|tmp\)$/d")"
  234. [ -z "$boxes" ] && printf "\033[31mNo local mailboxes have been detected for %s.\033[0m\\nThis means that mbsync has not been successfully run.\\nRun mbsync, and if it has an error, be sure to check your password and server settings manually if needbe.\\n" "$title" && return
  235. printf "Setting default mailboxes for your Inbox, Sent, Drafts and Trash in mutt...\\n"
  236. spoolfile=$(echo "$boxes" | grep -i -m 1 inbox | sed 's/=/+/g')
  237. record=$(echo "$boxes" | grep -i -m 1 sent | sed 's/=/+/g')
  238. postponed=$(echo "$boxes" | grep -i -m 1 draft | sed 's/=/+/g')
  239. trash=$(echo "$boxes" | grep -i -m 1 trash | sed 's/=/+/g')
  240. sed -ibu "/^mailboxes\|^set record\|^set postponed\|^set trash\|^set spoolfile/d" "$accdir/$idnum-$title.muttrc" ; rm -f "$accdir/$idnum-$title.muttrcbu"
  241. { echo "set spoolfile = \"$spoolfile\""; echo "set record = \"$record\""; echo "set postponed = \"$postponed\""; echo "set trash = \"$trash\""; } >> "$accdir/$idnum-$title.muttrc"
  242. echo "mailboxes $(echo "$boxes" | sed -e "s/^\|$/\"/g" | tr "\n" " ")" >> "$accdir/$idnum-$title.muttrc"
  243. printf "Setting up your keyboard shortcuts for jumping between mailboxes...\\n"
  244. sed -ibu "/# mw-autogenerated/d" "$accdir/$idnum-$title.muttrc" ; rm -f "$accdir/$idnum-$title.muttrcbu"
  245. echo "$boxes" | grep -i inbox | head -n 1 | formatShortcut i inbox
  246. echo "$boxes" | grep -i sent | head -n 1 | formatShortcut s sent
  247. echo "$boxes" | grep -i draft | head -n 1 | formatShortcut d drafts
  248. echo "$boxes" | grep -i trash | head -n 1 | formatShortcut t trash
  249. echo "$boxes" | grep -i spam | head -n 1 | formatShortcut S spam
  250. echo "$boxes" | grep -i junk | head -n 1 | formatShortcut j junk
  251. echo "$boxes" | grep -i archive | head -n 1 | formatShortcut a archive
  252. [ "$accounttype" = "offline" ] && printf "All done.\\n\033[33mYou should now be able to run \`\033[32mmbsync %s\033[33m\` to begin to download your mail.\033[0m\\n" "$title"
  253. command -V urlview >/dev/null 2>&1 && [ ! -f "$HOME/.urlview" ] && echo "COMMAND \$BROWSER" > "$HOME/.urlview"
  254. return 0
  255. }
  256. confirm() { printf "Do you want to %s? [yes/N]\\n\t" "$@" && read -r input && ! echo "$input" | grep -i "^yes$" >/dev/null && printf "That doesn't seem like a yes to me.\\n\\n" && return 1
  257. printf "Are you really, really sure you want to %s?\\n\t" "$@" && read -r input && ! echo "$input" | grep -i "^yes$" >/dev/null && printf "That doesn't seem like a yes to me.\\n\\n" && return 1
  258. return 0 ;}
  259. pick() { printf "Select an accounts to %s:\\n" "$1"
  260. list
  261. read -r input
  262. [ -z "$input" ] && return 1
  263. title="$(echo "$accounts" | grep "$input" | awk '{print $2}')"
  264. [ -z "$title" ] && printf "Invalid response." && return 1
  265. return 0 ;}
  266. delete() { sed -ibu "/IMAPStore $title-remote$/,/# End profile/d" "$mbsyncrc" ; rm -rf "$mbsyncrc"bu
  267. rm -rf "${cachedir:?}/${title:?}" "$accdir/"[1-9]"-$title.muttrc"
  268. sed -ibu "/[0-9]-$title.muttrc/d" "$muttrc" ; rm -f "$muttrc"bu
  269. sed -ibu "/account $title/,/^\(\s*$\|account\)/d" "$msmtprc"; rm -f "$msmtprc"bu
  270. }
  271. choosecron() { ! pgrep cron >/dev/null && echo "No cron manager running. Install/enable one and then select this option again." && return 1
  272. if crontab -l | grep mailsync >/dev/null; then
  273. echo "Active mail sync cronjob detected. Do you want to remove it?"
  274. printf "\033[36m\t"
  275. read -r rmyn
  276. printf "\033[0m"
  277. echo "$rmyn" | grep -i "^y\(es\)*$" >/dev/null && crontab -l | sed '/mailsync/d' | crontab - >/dev/null && echo "Mail sync turned off."
  278. else
  279. echo "How many minutes between each mail sync?"
  280. printf "\033[36m\t"
  281. read -r minnum
  282. printf "\033[0m"
  283. while ! echo "$minnum" | grep "^[0-9]\+$" >/dev/null; do
  284. printf "That doesn't look like a number. How many minutes between each mail sync?\\n\033[36m\t"
  285. read -r minnum
  286. printf "\033[0m"
  287. done
  288. (crontab -l; echo "*/$minnum * * * * $(type mailsync | cut -d' ' -f3) >/dev/null 2>&1") | crontab - >/dev/null &&
  289. echo "Cronjob added. Mail will sync every $minnum minutes. Be sure you have your cron manager running."
  290. fi ;}
  291. asktype() { while : ; do
  292. printf "Do you want to keep your mail for this account offline with mbsync? [yes/no]\\n\t"
  293. read -r offnot
  294. case "$offnot" in
  295. [Yy][Ee][Ss]) accounttype="offline" && break ;;
  296. [Nn][Oo]) accounttype="online" && break ;;
  297. *) echo "Write out either yes or no completely. Try again or press ctrl-c to quit." ;;
  298. esac; done ;}
  299. purge() { confirm "delete all account data" || exit
  300. rm -rf "$mbsyncrc" "$accdir" "$HOME/.config/msmtp" "$cachedir"
  301. crontab -l | sed '/mailsync/d' | crontab - >/dev/null
  302. echo "All configs and account settings have been purged."
  303. sed -ibu "/\# mw-autogenerated/d" "$muttrc" ; rm -f "$muttrc"bu
  304. }
  305. notmuchauto() { \
  306. [ -z "$NOTMUCH_CONFIG" ] && NOTMUCH_CONFIG="$HOME/.notmuch-config"
  307. [ -f "$NOTMUCH_CONFIG" ] && return 0
  308. nmbasic="[database]
  309. path=$maildir
  310. [user]
  311. name=$realname
  312. primary_email=$fulladdr
  313. [new]
  314. tags=unread;inbox;
  315. ignore=.mbsyncstate;.uidvalidity
  316. [search]
  317. exclude_tags=deleted;spam;
  318. [maildir]
  319. synchronize_flags=true
  320. [crypto]
  321. gpg_path=$GPG"
  322. echo "$nmbasic" > "$NOTMUCH_CONFIG" ;}
  323. trap 'echo -e "\033[0m\n"; exit' INT ABRT
  324. case "$1" in
  325. ls) list ;;
  326. add) asktype && askinfo && tryconnect && finalize || delete ;;
  327. pass) pick "change the password of" && getpass ;;
  328. delete) pick delete && confirm "delete the \`$title\` profile" && delete ;;
  329. purge) purge ;;
  330. cron) choosecron ;;
  331. *) cat << EOF
  332. mw: mutt-wizard, auto-configure email accounts for mutt
  333. including downloadable mail with \`isync\`.
  334. Allowed options:
  335. add Add and autoconfigure an email address (9 max.)
  336. ls List configured accounts
  337. delete Pick an account to delete
  338. purge Delete all accounts and settings
  339. cron Enable or disable an autosync via cronjob
  340. all else Print this message
  341. NOTE: Once at least one account is added, you can run
  342. \`mbsync -a\` to begin downloading mail.
  343. EOF
  344. esac